## libengine-gost-openssl1.1 1.1.0.1

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8)
project(ccgost C)

if (CMAKE_C_COMPILER_ID MATCHES "Clang")
   message(STATUS "Using Clang and adding -Qunused-arguments flag")
   set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Qunused-arguments")
endif()

set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c98 -O3 -Werror -Qunused-arguments -Wno-unused-function -Wno-missing-braces -Wall")
set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -O2 -Werror -Wall -Wno-unused-parameter -Wno-unused-function -Wno-missing-braces -ggdb")

include (TestBigEndian)
TEST_BIG_ENDIAN(IS_BIG_ENDIAN)
if(IS_BIG_ENDIAN)
 message(STATUS "BIG_ENDIAN")
else()
 message(STATUS "LITTLE_ENDIAN")
 set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c98 -O3 -Werror -Wall")
 set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -DL_ENDIAN")
endif()

set(BIN_DIRECTORY bin)

set(OUTPUT_DIRECTORY ${CMAKE_SOURCE_DIR}/${BIN_DIRECTORY})

#set(CMAKE_ARCHIVE_OUTPUT_DIRECTORY ${OUTPUT_DIRECTORY})
set(CMAKE_LIBRARY_OUTPUT_DIRECTORY ${OUTPUT_DIRECTORY})
set(CMAKE_RUNTIME_OUTPUT_DIRECTORY ${OUTPUT_DIRECTORY})

set(GOST_89_SOURCE_FILES
        gost89.c
        gost89.h
        )

set(GOST_HASH_SOURCE_FILES
        gosthash.c
        gosthash.h
        )

set(GOST_HASH_2012_SOURCE_FILES
        gosthash2012.c
        gosthash2012.h
        gosthash2012_const.h
        gosthash2012_precalc.h
        gosthash2012_ref.h
        gosthash2012_sse2.h
        )

set(GOST_GRASSHOPPER_SOURCE_FILES
        gost_grasshopper.h
        gost_grasshopper_core.h
        gost_grasshopper_core.c
        gost_grasshopper_defines.h
        gost_grasshopper_defines.c
        gost_grasshopper_math.h
        gost_grasshopper_galois_precompiled.c
        gost_grasshopper_precompiled.c
        gost_grasshopper_cipher.h
        gost_grasshopper_cipher.c
        gost_grasshopper_mac.h
        gost_grasshopper_mac.c
        )

set(GOST_CORE_SOURCE_FILES
        e_gost_err.c
        e_gost_err.h
        gost_asn1.c
        gost_crypt.c
        gost_ctl.c
        gost_eng.c
        gost_keywrap.c
        gost_keywrap.h
        gost_lcl.h
        gost_params.c
        )

set(GOST_EC_SOURCE_FILES
        gost_ec_keyx.c
        gost_ec_sign.c
        )

set(GOST_LIB_SOURCE_FILES
        ${GOST_EC_SOURCE_FILES}
        ${GOST_89_SOURCE_FILES}
        ${GOST_HASH_SOURCE_FILES}
        ${GOST_GRASSHOPPER_SOURCE_FILES}
        ${GOST_HASH_2012_SOURCE_FILES})

set(GOST_ENGINE_SOURCE_FILES
        ${GOST_CORE_SOURCE_FILES}
        gost_ameth.c
        gost_md.c
        gost_md2012.c
        gost_pmeth.c)

add_library(gost STATIC ${GOST_LIB_SOURCE_FILES})
set_target_properties(gost PROPERTIES POSITION_INDEPENDENT_CODE ON)

add_library(gost_engine MODULE ${GOST_ENGINE_SOURCE_FILES})
set_target_properties(gost_engine PROPERTIES PREFIX "" OUTPUT_NAME "gost")

target_link_libraries(gost_engine crypto gost)

set(GOST_12_SUM_SOURCE_FILES
        gost12sum.c
        )

add_executable(gost12sum ${GOST_12_SUM_SOURCE_FILES})

target_link_libraries(gost12sum gost)

set(GOST_SUM_SOURCE_FILES
        gostsum.c
        )

add_executable(gostsum ${GOST_SUM_SOURCE_FILES})

target_link_libraries(gostsum gost)

set(GOST_SUM_12_SOURCE_FILES
        gostsum12.c
        )

#add_executable(gostsum12 ${GOST_SUM_12_SOURCE_FILES})
#
#target_link_libraries(gostsum12 gost)

=== debian/changelog ===
libengine-gost-openssl1.1 (1.1.0.1-1) unstable; urgency=low

  * Initial upload
  * Closes: #870625

 -- Wartan Hachaturow <wart@debian.org>  Fri, 11 Aug 2017 19:34:28 +0300

=== debian/control ===
Source: libengine-gost-openssl1.1
Section: libs
Priority: extra
Maintainer: Wartan Hachaturow <wart@debian.org>
Build-Depends: debhelper (>= 9), cmake, libssl-dev, openssl
Standards-Version: 3.9.5
Homepage: https://github.com/gost-engine/engine
Vcs-Git: https://github.com/gost-engine/engine.git

Package: libengine-gost-openssl1.1
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Loadable module for openssl implementing GOST algorithms
 This package contains loadable module for openssl library, which
 implements (in software) Russian national standard (GOST) cryptography
 algorithms.

Package: gostsum
Architecture: any
Section: utils
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Utility to compute GOST hashes
 This package contain utilities to compute GOST hashsums
 gostsum - computes GOST R 34.11-94 hash
 gost12sum - computes GOST R 34.11-2012 hash

## libengine-gost-openssl1.1 1.1.0.3

=== debian/changelog ===
libengine-gost-openssl1.1 (1.1.0.3-1ubuntu1) jammy; urgency=medium

  * Stopgap patches for OpenSSL3 before migrating to provider API:
    - d/rules: downgrade deprecation errors to warnings to fix the build
      against OpenSSL 3
    - d/p/OpenSSL3.patch: Fix several const-correctness issues introduced
      by OpenSSL 3 API changes.

 -- Simon Chopin <simon.chopin@canonical.com>  Tue, 30 Nov 2021 17:26:08 +0100

libengine-gost-openssl1.1 (1.1.0.3-1build1) jammy; urgency=medium

  * No-change rebuild against openssl3

 -- Simon Chopin <simon.chopin@canonical.com>  Mon, 29 Nov 2021 13:44:10 +0100

libengine-gost-openssl1.1 (1.1.0.3-1) unstable; urgency=medium

  * New upstream version

  * Closes: #898823, #906734

 -- Wartan Hachaturow <wart@debian.org>  Sun, 16 Sep 2018 18:58:16 +0300

=== debian/control ===
--- 
+++ 
@@ -1,7 +1,8 @@
 Source: libengine-gost-openssl1.1
 Section: libs
 Priority: extra
-Maintainer: Wartan Hachaturow <wart@debian.org>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Wartan Hachaturow <wart@debian.org>
 Build-Depends: debhelper (>= 9), cmake, libssl-dev, openssl
 Standards-Version: 3.9.5
 Homepage: https://github.com/gost-engine/engine

=== debian/rules ===
#!/usr/bin/make -f
# See debhelper(7) (uncomment to enable)
# output every command that modifies files on the build system.
#DH_VERBOSE = 1

# see EXAMPLES in dpkg-buildflags(1) and read /usr/share/dpkg/*
DPKG_EXPORT_BUILDFLAGS = 1

export DEB_CFLAGS_MAINT_APPEND = -Wno-error=deprecated-declarations

include /usr/share/dpkg/default.mk

# see FEATURE AREAS in dpkg-buildflags(1)
#export DEB_BUILD_MAINT_OPTIONS = hardening=+all

# see ENVIRONMENT in dpkg-buildflags(1)
# package maintainers to append CFLAGS
#export DEB_CFLAGS_MAINT_APPEND  = -Wall -pedantic
# package maintainers to append LDFLAGS
#export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed

OPENSSL_ENGINE_DIR=$(shell openssl version -e |sed -e 's/^[^.]*"//' -e 's/".*$$//')
# main packaging script based on dh7 syntax
%:
	dh $@ 

# debmake generated override targets
# This is example for Cmake (See http://bugs.debian.org/641051 )
#override_dh_auto_configure:
#	dh_auto_configure -- \
#	-DCMAKE_LIBRARY_PATH=$(DEB_HOST_MULTIARCH)
override_dh_install:
	install -d -m 755 $(CURDIR)/debian/libengine-gost-openssl1.1/$(OPENSSL_ENGINE_DIR)
	install -d -m 755 $(CURDIR)/debian/gostsum/usr/bin
	install -d -m 755 $(CURDIR)/debian/gostsum/usr/share/man/man1
	install -m 755 bin/gost.so $(CURDIR)/debian/libengine-gost-openssl1.1/$(OPENSSL_ENGINE_DIR)
	install -m 755 bin/gostsum $(CURDIR)/debian/gostsum/usr/bin
	install -m 755 bin/gost12sum $(CURDIR)/debian/gostsum/usr/bin
	install -m 644 gostsum.1 $(CURDIR)/debian/gostsum/usr/share/man/man1
	install -m 644 gost12sum.1 $(CURDIR)/debian/gostsum/usr/share/man/man1
#verride_dh_clean:
#	rm -rf bin debian/debhelper-build-stamp



# Please also look if there are files or directories which have a
# different copyright/license attached and list them here.
# Please avoid to pick license terms that are more restrictive than the
# packaged work, as it may make Debian's contributions unacceptable upstream.
